
import 'package:flutter/material.dart';
import 'package:otter_json/otter_json.dart';

class GeneratedJsonModule implements JsonModule {
  @override
  Map<String, JsonSerializer> serializers() {
    return {
      'TestClass': _TestClassJsonSerializer(),
    };
  }
}


class _TestClassJsonSerializer implements JsonSerializer<TestClass, Map<String, dynamic>>{
  @override
  TestClass decode(Map<String, dynamic> output) {
    var object = TestClass();
    object.string = OtterInternal.decode(output['string']);
    object.integer = OtterInternal.decode(output['integer']);
    object.dou = OtterInternal.decode(output['dou']);
    object.boolean = OtterInternal.decode(output['boolean']);
    object.number = OtterInternal.decode(output['number']);
    object.color = OtterInternal.decode(output['color']);
    object.dateTime = OtterInternal.decode(output['dateTime']);
    object.duration = OtterInternal.decode(output['duration']);
    return object;
  }

  @override
  Map<String, dynamic> encode(TestClass input) {
    return {
      'string': OtterInternal.encode(input.string),
      'integer': OtterInternal.encode(input.integer),
      'dou': OtterInternal.encode(input.dou),
      'boolean': OtterInternal.encode(input.boolean),
      'number': OtterInternal.encode(input.number),
      'color': OtterInternal.encode(input.color),
      'dateTime': OtterInternal.encode(input.dateTime),
      'duration': OtterInternal.encode(input.duration),
    };
  }
}

class TestClass {
  String string;
  int integer;
  double dou;
  bool boolean;
  num number;
  Color color;
  DateTime dateTime;
  Duration duration;
}
